
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class League_paymentsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const league_payments = await db.league_payments.create(
            {
                id: data.id || undefined,
        
        fee_amount: data.fee_amount
        ||
        null
            ,
            
        amount_paid: data.amount_paid
        ||
        null
            ,
            
        payment_status: data.payment_status
        ||
        null
            ,
            
        last_paid_at: data.last_paid_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await league_payments.setLeague( data.league || null, {
            transaction,
        });
        
        await league_payments.setPlayer( data.player || null, {
            transaction,
        });
        
        await league_payments.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return league_payments;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const league_paymentsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                fee_amount: item.fee_amount
            ||
            null
            ,
            
                amount_paid: item.amount_paid
            ||
            null
            ,
            
                payment_status: item.payment_status
            ||
            null
            ,
            
                last_paid_at: item.last_paid_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const league_payments = await db.league_payments.bulkCreate(league_paymentsData, { transaction });

        // For each item created, replace relation files
        

        return league_payments;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const league_payments = await db.league_payments.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.fee_amount !== undefined) updatePayload.fee_amount = data.fee_amount;
        
        
        if (data.amount_paid !== undefined) updatePayload.amount_paid = data.amount_paid;
        
        
        if (data.payment_status !== undefined) updatePayload.payment_status = data.payment_status;
        
        
        if (data.last_paid_at !== undefined) updatePayload.last_paid_at = data.last_paid_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await league_payments.update(updatePayload, {transaction});

        
        
        if (data.league !== undefined) {
            await league_payments.setLeague(
              
              data.league,
              
              { transaction }
            );
        }
        
        if (data.player !== undefined) {
            await league_payments.setPlayer(
              
              data.player,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await league_payments.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return league_payments;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const league_payments = await db.league_payments.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of league_payments) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of league_payments) {
                await record.destroy({transaction});
            }
        });


        return league_payments;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const league_payments = await db.league_payments.findByPk(id, options);

        await league_payments.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await league_payments.destroy({
            transaction
        });

        return league_payments;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const league_payments = await db.league_payments.findOne(
            { where },
            { transaction },
        );

        if (!league_payments) {
            return league_payments;
        }

        const output = league_payments.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.league = await league_payments.getLeague({
            transaction
        });
        
        
        output.player = await league_payments.getPlayer({
            transaction
        });
        
        
        output.organizations = await league_payments.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.leagues,
        as: 'league',
        
        where: filter.league ? {
          [Op.or]: [
            { id: { [Op.in]: filter.league.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.league.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.players,
        as: 'player',
        
        where: filter.player ? {
          [Op.or]: [
            { id: { [Op.in]: filter.player.split('|').map(term => Utils.uuid(term)) } },
            {
              display_name: {
                [Op.or]: filter.player.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            

            
            if (filter.fee_amountRange) {
                const [start, end] = filter.fee_amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    fee_amount: {
                    ...where.fee_amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    fee_amount: {
                    ...where.fee_amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.amount_paidRange) {
                const [start, end] = filter.amount_paidRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    amount_paid: {
                    ...where.amount_paid,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    amount_paid: {
                    ...where.amount_paid,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.last_paid_atRange) {
                const [start, end] = filter.last_paid_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    last_paid_at: {
                    ...where.last_paid_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    last_paid_at: {
                    ...where.last_paid_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.payment_status) {
                where = {
                    ...where,
                payment_status: filter.payment_status,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.league_payments.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'league_payments',
                        'payment_status',
                        query,
                    ),
                ],
            };
        }

        const records = await db.league_payments.findAll({
            attributes: [ 'id', 'payment_status' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['payment_status', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.payment_status,
        }));
    }

    
};

